// Base64.h
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _BASE64_H
#define _BASE64_H


class Base64
{
public:
	Base64();
	~Base64();

	// file to file
	void encode_file(char *s,char *outfn);

	// input buffer to vector<string>
	void encode64(char *in,size_t len,vector<string> &out);

	// file to vector<string>
	void encode_from_file(char *,vector<string> &);

	// file to file
	void decode_file(char *s,char *outfn);

	// vector<string> to file
	void decode_to_file(vector<string> &body,char *outfn);

	// file to FILE *
	void decode_stdout(char *fn,FILE *out = stdout);

	// char * to FILE *
	void decode_to_stdout(const string &,FILE * = stdout);

	// vector<string> to FILE *
	void decode_to_stdout(vector<string> &,FILE * = stdout);

private:
	void setupbase64();
	int setupdecode(char c);
	int reverse(char c);
	void encode(char *in,char *out);
	int decode(char c);
	void decode_string(char *s, unsigned char *output, int &l);
};


#endif // _BASE64_H
