// Ticks.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _TICKS_H
#define _TICKS_H

#include <sys/time.h>
#include <unistd.h>

class Ticks
{
public:
	Ticks() {
		struct timeval tv;
		struct timezone tz;
		gettimeofday(&tv,&tz);
		d0 = tv.tv_sec;
		d0 *= 1000000;
		d0 += tv.tv_usec;
		dstop = d0;
	}
	~Ticks() {
	}
	void Stop() {
		struct timeval tv;
		struct timezone tz;
		gettimeofday(&tv,&tz);
		dstop = tv.tv_sec;
		dstop *= 1000000;
		dstop += tv.tv_usec;
	}
	void Time(char *s) {
		double d = dstop - d0;
		sprintf(s,"%.4f sec",d / 1000000);
	}
private:
	double d0;
	double dstop;
};


#endif // _TICKS_H
