// Web.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _WEB_H
#define _WEB_H

#include <vector>
using std::vector;

class Form;
class Cookies;

//! The CGI main class

class Web 
{
public:
	Web();
	Web(const string &,const string &);
	virtual ~Web();
	void Init();
	void SetCookieDomain(const string &);
	void SetCookiePath(const string &);
	void SetCookie(const string &name,const string &value);
	void SetCookie(const string &name,long value);
	void SetCookie(const string &name,int value);
	void Execute();
	void SetCgiName(const string &);
	string GetCgiName();
	Form *GetForm();
	Cookies *GetCookies();

	void RegWebForm(WebForm *);

	virtual void ReadCookies();
	virtual void FormInput();
	virtual void CreateHeader();
	virtual void GenerateDocument();

	string GetDate();
	string GetRequestMethod();

protected:
	Form *m_pclForm;
	Cookies *m_pclCookies;

private:
	string m_strCookieDomain;
	string m_strCookiePath;
	string m_strCgiName;
	vector<WebForm *> m_forms;
	string m_date;
	string m_method; // request_method
};


#endif // _WEB_H
