/**
 **	list.h - linked list stuff
 **
 **	Written: 1999-Feb-10 grymse@telia.com
 **/

/*
Copyright (C) 1999  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _LIST_H
#define _LIST_H


//! Base linked list struct

typedef struct liststruct
{
	struct liststruct *next;
} LIST;

//! Base linked string list struct

typedef struct sliststruct
{
	struct sliststruct *next;
	char s[0];
} SLIST;

void addlist(void *_base,void *item);
void addlistl(void *_base,void *item);
void removelist(void *_base,void *item);
void savelist(void *_base,int size,char *filename);
void loadlist(void *_base,int size,char *filename);
void addlistsort(void *_base,SLIST *item);
void freelist(void *);
long listlen(void *_base);

#ifdef WIN32
#define strcasecmp stricmp
#endif

#endif // _LIST_H
